const { DataTypes } = require('sequelize');

module.exports = (sequelize) => {
    const EmployeeGroup = sequelize.define('employeegroup', {
        id: {
            type: DataTypes.INTEGER,
            autoIncrement: true,
            primaryKey: true
        },
        creation: { type: DataTypes.DATE, allowNull: false },
        modified: { type: DataTypes.DATE, allowNull: false },
        modified_by: { type: DataTypes.INTEGER, allowNull: false },
        owner: { type: DataTypes.INTEGER, allowNull: false },

        // main
        name: { type: DataTypes.STRING(150), allowNull: false },
        display_name: { type: DataTypes.STRING(150), allowNull: false },
        description: { type: DataTypes.TEXT, allowNull: true },

        // fk
        company_id: {
            type: DataTypes.INTEGER,
            allowNull: true,
        },
    }, {
        tableName: 'employeegroups',
        freezeTableName: true
    });

    /**
     * Associates the EmployeeGroup model with other models.
     * @param {object} models - The models to associate with.
     * @description
     */
    EmployeeGroup.associate = (models) => {
        EmployeeGroup.belongsTo(models.Company, { as: 'company', foreignKey: 'company_id' });
        EmployeeGroup.hasMany(models.EmployeeGroupTable, { as: 'employeegrouptable', foreignKey: 'employeegroup_id' })
    };

    return EmployeeGroup;
};
